/*
  Copyright (c) 2016 Genome Research Ltd.

  Author: Jouni Sirén <jouni.siren@iki.fi>

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include <cstdlib>
#include <iostream>

#include <sdsl/int_vector.hpp>

int
main(int argc, char** argv)
{
  if(argc < 2)
  {
    std::cerr << "Usage: convert_to_surf base_name" << std::endl;
    std::exit(EXIT_SUCCESS);
  }

  sdsl::int_vector<8> text;
  sdsl::load_vector_from_file(text, argv[1], 1);

  // Convert 0s to 1s (document borders) and 1s to 2s.
  for(uint64_t i = 0; i < text.size(); i++)
  {
    if(text[i] <= 1) { text[i]++; }
  }

  text.resize(text.size() + 1);
  text[text.size() - 1] = 0;
  sdsl::store_to_file(text, "text_SURF.sdsl");

  std::exit(EXIT_FAILURE);
}
